<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: GeneralUtils.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">GeneralUtils.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * GeneralUtils.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: May 20, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_GENERALUTILS_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_GENERALUTILS_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;esp_err.h&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="classGeneralUtils.html">   19</a></span>&#160;<span class="keyword">class </span><a class="code" href="classGeneralUtils.html">GeneralUtils</a> {</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span>        <a class="code" href="classGeneralUtils.html#af43c8ecc3449ea441a2a8e88a50a34d6">base64Decode</a>(<span class="keyword">const</span> std::string&amp; in, std::string* out);</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span>        <a class="code" href="classGeneralUtils.html#abe8373207df0ef16bc66338b4ec8d298">base64Encode</a>(<span class="keyword">const</span> std::string&amp; in, std::string* out);</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span>        <a class="code" href="classGeneralUtils.html#a1698e9a6f3f4a3b49e00a4c7b200fa6b">dumpInfo</a>();</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">bool</span>        <a class="code" href="classGeneralUtils.html#ade237631b5595e2426f9e86fc6e38932">endsWith</a>(std::string str, <span class="keywordtype">char</span> c);</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classGeneralUtils.html#a25e466e54ff002f54bfb7e1f43bd401b">errorToString</a>(esp_err_t errCode);</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="classGeneralUtils.html#ad485c229090167eaa4c8a70028ce5a52">wifiErrorToString</a>(uint8_t value);</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span>        <a class="code" href="classGeneralUtils.html#a0624d2bba035e50c4073074da675a606">hexDump</a>(<span class="keyword">const</span> uint8_t* pData, uint32_t length);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classGeneralUtils.html#a6060e23d9a79cad1d9684282b1b8eec3">ipToString</a>(uint8_t* ip);</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keyword">static</span> std::vector&lt;std::string&gt; <a class="code" href="classGeneralUtils.html#addd9bb2f367a86841e48f5aa67f1d003">split</a>(std::string source, <span class="keywordtype">char</span> delimiter);</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classGeneralUtils.html#a03192aa2510994528f5cb095f9a455fb">toLower</a>(std::string&amp; value);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classGeneralUtils.html#a4b4d634fc97c00316fc5ab7655f4a001">trim</a>(<span class="keyword">const</span> std::string&amp; str);</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;};</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_GENERALUTILS_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classGeneralUtils_html"><div class="ttname"><a href="classGeneralUtils.html">GeneralUtils</a></div><div class="ttdoc">General utilities.</div><div class="ttdef"><b>Definition:</b> GeneralUtils.h:19</div></div>
<div class="ttc" id="classGeneralUtils_html_a1698e9a6f3f4a3b49e00a4c7b200fa6b"><div class="ttname"><a href="classGeneralUtils.html#a1698e9a6f3f4a3b49e00a4c7b200fa6b">GeneralUtils::dumpInfo</a></div><div class="ttdeci">static void dumpInfo()</div><div class="ttdoc">Dump general info to the log. Data includes:</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:114</div></div>
<div class="ttc" id="classGeneralUtils_html_ade237631b5595e2426f9e86fc6e38932"><div class="ttname"><a href="classGeneralUtils.html#ade237631b5595e2426f9e86fc6e38932">GeneralUtils::endsWith</a></div><div class="ttdeci">static bool endsWith(std::string str, char c)</div><div class="ttdoc">Does the string end with a specific character?</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:132</div></div>
<div class="ttc" id="classGeneralUtils_html_addd9bb2f367a86841e48f5aa67f1d003"><div class="ttname"><a href="classGeneralUtils.html#addd9bb2f367a86841e48f5aa67f1d003">GeneralUtils::split</a></div><div class="ttdeci">static std::vector&lt; std::string &gt; split(std::string source, char delimiter)</div><div class="ttdoc">Split a string into parts based on a delimiter.</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:355</div></div>
<div class="ttc" id="classGeneralUtils_html_a25e466e54ff002f54bfb7e1f43bd401b"><div class="ttname"><a href="classGeneralUtils.html#a25e466e54ff002f54bfb7e1f43bd401b">GeneralUtils::errorToString</a></div><div class="ttdeci">static const char * errorToString(esp_err_t errCode)</div><div class="ttdoc">Convert an ESP error code to a string.</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:372</div></div>
<div class="ttc" id="classGeneralUtils_html_abe8373207df0ef16bc66338b4ec8d298"><div class="ttname"><a href="classGeneralUtils.html#abe8373207df0ef16bc66338b4ec8d298">GeneralUtils::base64Encode</a></div><div class="ttdeci">static bool base64Encode(const std::string &amp;in, std::string *out)</div><div class="ttdoc">Encode a string into base 64.</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:65</div></div>
<div class="ttc" id="classGeneralUtils_html_a03192aa2510994528f5cb095f9a455fb"><div class="ttname"><a href="classGeneralUtils.html#a03192aa2510994528f5cb095f9a455fb">GeneralUtils::toLower</a></div><div class="ttdeci">static std::string toLower(std::string &amp;value)</div><div class="ttdoc">Convert a string to lower case.</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:528</div></div>
<div class="ttc" id="classGeneralUtils_html_af43c8ecc3449ea441a2a8e88a50a34d6"><div class="ttname"><a href="classGeneralUtils.html#af43c8ecc3449ea441a2a8e88a50a34d6">GeneralUtils::base64Decode</a></div><div class="ttdeci">static bool base64Decode(const std::string &amp;in, std::string *out)</div><div class="ttdoc">Decode a chunk of data that is base64 encoded.</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:169</div></div>
<div class="ttc" id="classGeneralUtils_html_a4b4d634fc97c00316fc5ab7655f4a001"><div class="ttname"><a href="classGeneralUtils.html#a4b4d634fc97c00316fc5ab7655f4a001">GeneralUtils::trim</a></div><div class="ttdeci">static std::string trim(const std::string &amp;str)</div><div class="ttdoc">Remove white space from a string.</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:539</div></div>
<div class="ttc" id="classGeneralUtils_html_ad485c229090167eaa4c8a70028ce5a52"><div class="ttname"><a href="classGeneralUtils.html#ad485c229090167eaa4c8a70028ce5a52">GeneralUtils::wifiErrorToString</a></div><div class="ttdeci">static const char * wifiErrorToString(uint8_t value)</div><div class="ttdoc">Convert a wifi_err_reason_t code to a string.</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:454</div></div>
<div class="ttc" id="classGeneralUtils_html_a6060e23d9a79cad1d9684282b1b8eec3"><div class="ttname"><a href="classGeneralUtils.html#a6060e23d9a79cad1d9684282b1b8eec3">GeneralUtils::ipToString</a></div><div class="ttdeci">static std::string ipToString(uint8_t *ip)</div><div class="ttdoc">Convert an IP address to string.</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:342</div></div>
<div class="ttc" id="classGeneralUtils_html_a0624d2bba035e50c4073074da675a606"><div class="ttname"><a href="classGeneralUtils.html#a0624d2bba035e50c4073074da675a606">GeneralUtils::hexDump</a></div><div class="ttdeci">static void hexDump(const uint8_t *pData, uint32_t length)</div><div class="ttdoc">Dump a representation of binary data to the console.</div><div class="ttdef"><b>Definition:</b> GeneralUtils.cpp:299</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
